Index: c/src/ada-tests/sptests/sp03/config.h
===================================================================
--- c/src/ada-tests/sptests/sp03/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp03/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,33 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */
Index: c/src/ada-tests/sptests/sp04/config.h
===================================================================
--- c/src/ada-tests/sptests/sp04/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp04/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,36 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_MAXIMUM_USER_EXTENSIONS     1
+#define CONFIGURE_TICKS_PER_TIMESLICE       100
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */
Index: c/src/ada-tests/sptests/sp05/config.h
===================================================================
--- c/src/ada-tests/sptests/sp05/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp05/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,35 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_TICKS_PER_TIMESLICE       100
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */
Index: c/src/ada-tests/sptests/sp06/config.h
===================================================================
--- c/src/ada-tests/sptests/sp06/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp06/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,35 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_TICKS_PER_TIMESLICE       100
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */
Index: c/src/ada-tests/sptests/sp07/config.h
===================================================================
--- c/src/ada-tests/sptests/sp07/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp07/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,36 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_MAXIMUM_USER_EXTENSIONS     1
+#define CONFIGURE_TICKS_PER_TIMESLICE       100
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */
Index: c/src/ada-tests/sptests/sp08/config.h
===================================================================
--- c/src/ada-tests/sptests/sp08/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp08/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,35 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_TICKS_PER_TIMESLICE       100
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */
Index: c/src/ada-tests/sptests/sp09/config.h
===================================================================
--- c/src/ada-tests/sptests/sp09/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp09/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,42 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_MAXIMUM_TIMERS              1
+#define CONFIGURE_MAXIMUM_SEMAPHORES          2
+#define CONFIGURE_MAXIMUM_MESSAGE_QUEUES      1
+#define CONFIGURE_MAXIMUM_PARTITIONS          1
+#define CONFIGURE_MAXIMUM_REGIONS             1
+#define CONFIGURE_MAXIMUM_PERIODS             1
+#define CONFIGURE_MAXIMUM_USER_EXTENSIONS     0
+#define CONFIGURE_TICKS_PER_TIMESLICE       100
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */
Index: c/src/ada-tests/sptests/sp11/config.h
===================================================================
--- c/src/ada-tests/sptests/sp11/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp11/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,36 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_MAXIMUM_TIMERS              6
+#define CONFIGURE_TICKS_PER_TIMESLICE       100
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */
Index: c/src/ada-tests/sptests/sp12/config.h
===================================================================
--- c/src/ada-tests/sptests/sp12/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp12/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,36 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_MAXIMUM_SEMAPHORES         10
+#define CONFIGURE_TICKS_PER_TIMESLICE       100
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */
Index: c/src/ada-tests/sptests/sp13/config.h
===================================================================
--- c/src/ada-tests/sptests/sp13/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp13/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,36 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_MAXIMUM_MESSAGE_QUEUES     10
+#define CONFIGURE_TICKS_PER_TIMESLICE       100
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */
Index: c/src/ada-tests/sptests/sp14/config.h
===================================================================
--- c/src/ada-tests/sptests/sp14/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp14/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,36 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_MAXIMUM_TIMERS              1
+#define CONFIGURE_TICKS_PER_TIMESLICE       100
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */
Index: c/src/ada-tests/sptests/sp15/config.h
===================================================================
--- c/src/ada-tests/sptests/sp15/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp15/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,36 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_MAXIMUM_PARTITIONS          2
+#define CONFIGURE_TICKS_PER_TIMESLICE       100
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */
Index: c/src/ada-tests/sptests/sp16/config.h
===================================================================
--- c/src/ada-tests/sptests/sp16/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp16/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,36 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_MAXIMUM_REGIONS             4
+#define CONFIGURE_TICKS_PER_TIMESLICE       100
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */
Index: c/src/ada-tests/sptests/sp17/config.h
===================================================================
--- c/src/ada-tests/sptests/sp17/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
+++ c/src/ada-tests/sptests/sp17/config.h	(revision 82870abbb2a1e0ebba160142c447e41270727624)
@@ -0,0 +1,36 @@
+/*  config.h
+ *
+ *  This include file defines the Configuration Table for this test.
+ *
+ *  COPYRIGHT (c) 1989-1997.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may in
+ *  the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+
+/* configuration information */
+
+#define CONFIGURE_SPTEST
+
+#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_MICROSECONDS_PER_TICK   RTEMS_MILLISECONDS_TO_MICROSECONDS(25)
+#define CONFIGURE_TICKS_PER_TIMESLICE     1000
+
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS              10
+#define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
+#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              20
+#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
+
+#include <confdefs.h>
+
+/* end of include file */