Index: contrib/crossrpms/gdb/build.add
===================================================================
--- contrib/crossrpms/gdb/build.add	(revision a1bfb335c0cc274513e144da46e203bff29e000b)
+++ contrib/crossrpms/gdb/build.add	(revision 84019c592b9674f704bd67b3c6a6ab1665bcc611)
@@ -18,14 +18,7 @@
     %{build_sim} \
     %{?with_system_readline:--with-system-readline} \
-%if "%{gdb_version}" >= "6.6"
     --with-expat \
-%endif
-%if "%{gdb_version}" >= "6.8.50"
-%if %{with python}
-    --with-python \
-%else
-    --without-python \
-%endif
-%endif
+    %{?with_python:--with-python}%{!?with_python:--without-python} \
+    --with-gdb-datadir=%{_datadir}/@tool_target@-gdb \
     --with-sysroot=%{_prefix}/@tool_target@/sys-root \
     --prefix=%{_prefix} --bindir=%{_bindir} \
Index: contrib/crossrpms/gdb/gdb.add
===================================================================
--- contrib/crossrpms/gdb/gdb.add	(revision a1bfb335c0cc274513e144da46e203bff29e000b)
+++ contrib/crossrpms/gdb/gdb.add	(revision 84019c592b9674f704bd67b3c6a6ab1665bcc611)
@@ -13,12 +13,25 @@
 BuildRequires:  %{_host_rpmprefix}gcc
 
-%define build_sim --enable-sim
+%global build_sim --enable-sim
+
+# Whether to build against system readline
+# Default: yes
+%bcond_without system_readline
+
+# Whether to build python support
+%if "%{_build}" != "%{_host}"
+# Can't build python Cdn-X
+%bcond_with python
+%else
+%bcond_without python
+%endif
+%{?with_python:BuildRequires: %{_host_rpmprefix}python-devel}
 
 %if "@tool_target@" == "powerpc-rtems@rtems_api@"
 %if "%{_build}" != "%{_host}"
 # psim doesn't support Cdn-X
-%define build_sim --disable-sim
+%global build_sim --disable-sim
 %else
-%define build_sim --enable-sim --enable-sim-trace
+%global build_sim --enable-sim --enable-sim-trace
 %endif
 %endif
@@ -54,5 +67,4 @@
 %endif
 
-%if "%{gdb_version}" >= "6.6"
 # suse
 %if "%{?suse}" >= "10.3"
@@ -62,26 +74,7 @@
 BuildRequires: %{_host_rpmprefix}expat-devel
 %endif
-%endif
 
-%if "%{gdb_version}" < "6.7"
-%if "%{_build}" != "%{_host}"
-BuildRequires:  %{_host_rpmprefix}termcap-devel
-%endif
-%bcond_with system_readline
-%else
-%bcond_without system_readline
-%endif
 %{?with_system_readline:BuildRequires: %{_host_rpmprefix}readline-devel}
 BuildRequires:  %{_host_rpmprefix}ncurses-devel
-
-%if "%{gdb_version}" >= "6.8.50"
-%if "%{_build}" != "%{_host}"
-# Can't build python Cdn-X
-%bcond_with python
-%else
-%bcond_without python
-%endif
-%endif
-%{?with_python:BuildRequires: %{_host_rpmprefix}python-devel}
 
 %if %build_infos
@@ -89,11 +82,7 @@
 BuildRequires:	/sbin/install-info
 BuildRequires:	texinfo >= 4.2
+Requires:	@rpmprefix@gdb-common
+
 %endif
-
-%if %build_infos
-
-Requires:	@rpmprefix@gdb-common
-%endif
-
 @SOURCES@
 
Index: contrib/crossrpms/gdb/install.add
===================================================================
--- contrib/crossrpms/gdb/install.add	(revision a1bfb335c0cc274513e144da46e203bff29e000b)
+++ contrib/crossrpms/gdb/install.add	(revision 84019c592b9674f704bd67b3c6a6ab1665bcc611)
@@ -27,8 +27,7 @@
   rm -f ${RPM_BUILD_ROOT}%{_libdir}/lib@tool_target@-sim.a
 
-%if "%{gdb_version}" >= "7.0"
 # Bug in gdb-7.0, bogusly installs linux-only files
   somethinguseful=0
-  for f in ${RPM_BUILD_ROOT}%{_datadir}/gdb/syscalls/*.xml; do
+  for f in ${RPM_BUILD_ROOT}%{_datadir}/@tool_target@-gdb/syscalls/*.xml; do
     case $f in
     *linux.xml) rm -f $f;;
@@ -37,8 +36,13 @@
   done
   if test $somethinguseful -eq 0; then
-    rm -rf "${RPM_BUILD_ROOT}%{_datadir}/gdb/syscalls"
+    rm -rf "${RPM_BUILD_ROOT}%{_datadir}/@tool_target@-gdb/syscalls"
   fi
+
+%if "{gdb_version}" >= "7.3"
+%if ! %{with python}
+# gdb-7.3 doesn't honor --without-python correctly
+  rm -rf ${RPM_BUILD_ROOT}%{_datadir}/@tool_target@-gdb/python
 %endif
-
+%endif
   cd ..
 
Index: contrib/crossrpms/gdb/target-gdb.add
===================================================================
--- contrib/crossrpms/gdb/target-gdb.add	(revision a1bfb335c0cc274513e144da46e203bff29e000b)
+++ contrib/crossrpms/gdb/target-gdb.add	(revision 84019c592b9674f704bd67b3c6a6ab1665bcc611)
@@ -16,4 +16,5 @@
 %sysdir %{_prefix}
 %sysdir %{_prefix}/share
+%{?with_python:%{_datadir}/@tool_target@-gdb}
 
 %sysdir %{_mandir}